#ifndef YERBACON_RESERVEDIDENTIFIERS_HPP
#define YERBACON_RESERVEDIDENTIFIERS_HPP

#include <string>
#include <array>
#include "../Yerbacon.hpp"
#include <string_view>

static constinit const array identifiers {
    "class", "structure", "print", "print_line", "if", "else", "elseif"
};

enum class ReservedIdentifier: size_t {
    CLASS, STRUCT, PRINT_FUNCTION, PRINT_LINE_FUNCTION, CONDITION_STATEMENT, CONDITION_STATEMENT_BRANCH, CONDITION_STATEMENT_CONDITIONAL_BRANCH
};

inline const char* ID(const ReservedIdentifier& identifier) {
    return identifiers.at(reinterpret_cast<const size_t&>(identifier));
}

bool reserved(const string_view words) {
    return any_of(identifiers.cbegin(), identifiers.cend(), [&words](const auto& identifier) {
        return words == identifier;
    });
}

#endif //YERBACON_RESERVEDIDENTIFIERS_HPP
